package org.eso.ohs.core.dbb.client;



/**
 * Contains the widget configuration information of a DbbPanel.
 * The widgets of the DbbPanel are selected in the order set by 
 * the order param. The columns will be seen in the order of selection
 */
public class WidgetConfig implements Comparable {

    private int order_ = 0;
    private int position_ = -1;
    private String name_ = "";
    private String value_ = "";
    
    
    public WidgetConfig(String name, String value, int order, int position) {
	name_ = name;
	value_ = value;
	order_ = order;
	position_ = position;
    }
    
    public int getOrder(){
	return order_;
    };
    
    public void setOrder(int order) {
	order_ = order;
    }

     public String getName(){ 
	return name_;
    };
    
   public String getValue(){
	return value_;
    };

    public void setValue(String value) {
	value_ = value;
    }

    public int compareTo (Object wc) {
	return order_ - ((WidgetConfig)wc).getOrder();
    }
    

	public int getPosition() {
		return position_;
	}

	public void setPosition(int position) {
		this.position_ = position;
	}
}
