package org.eso.ohs.core.gui.models;

/**
 * A Document model to only permit the input of an equinox.
 * 
 * <p>
 * $Id: EquinoxModel.java,v 1.1 2004/02/17 10:35:21 tcanavan Exp $
 */

public class EquinoxModel extends InputMaskModel {

    /**
     * The regular expression describing legal buffer values.
     * Looking for values like: B1950 or J2000.
     * The B and J denote different measuring schemes,
     * something like centimeters and inches.
     * They refer to Besselian and Julian epochs, respectively.
     */
    private final static String legalValuesPattern_ =
	"(([BJ])?\\d{0,2}\\d{0,2}(\\.\\d{0,2})?)?";

    /**
     * Constructor for the model.
     */
    public EquinoxModel() {
	super(legalValuesPattern_);
    }

}

