package org.eso.ohs.dfs.docviewdatatrans;

import org.eso.ohs.core.docview.datatrans.ObjAdaptor;
import org.eso.ohs.instruments.TemplateSignature;

/**
 * A transducer to convert getValue() calls on a property of
 * type BusinessObject to getName() calls on the BusinessObject itself..
 *
 * <p>
 * $Id: TemplateSignatureAdaptor.java,v 1.1 2004/02/17 12:37:59 tcanavan Exp $
 */

public class TemplateSignatureAdaptor extends ObjAdaptor {

    /**
     * Construct a transducer.
     * 
     * @param cls   java.lang.Class object for the type of BusinessObject
     *		    who's name we're trying to display.
     */
    public TemplateSignatureAdaptor(Class cls) {
	super(cls);
    }

    public void setValue(Object obj) {
         //((TemplateSignature)super.getRawValue()).setTemplateName(obj.toString());
    }

    public void setReadWrite(boolean newValue) {
	if (newValue) {
	    throw new IllegalArgumentException(
		"IndirectNameAdaptor: write access not allowed"
	    );
	}
    }

    /**
     * Converts data from a String to a meta-level equivalent of the
     * actual property's type -- in this case a null operation.  Used
     * with reflection to set the new property value.
     * 
     * @param value the new value of the property.
     */
    public Object toMetaLevelObject(String value) {
	return value;
    }


    /**
     * Converts data to a String from the meta-level equivalent of the
     * actual property's type, i.e. from a java.lang.Long
     * to a long int.  Used with reflection to get
     * the current property value.
     *
     * @param value	value of the property.
     */
    public String fromMetaLevelObject(Object obj) {
	if (obj == null) {
	    return "";
	}
	else if (obj instanceof String) {
	    // XXX HACK because DbaseMgr.listObjects() returns
	    //		a String, not the BusinessObject!
	    return (String)obj;
	}
	else {
	    return ((TemplateSignature)obj).getTemplateName();
	}
    }

}

