/*
 * Created on 11.11.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eso.ohs.instruments;

/**
 * @author tcanavan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ReadmeTextAttribute extends ReadmeAttribute {

    private static final long serialVersionUID = -4378250031958121801L;
    
    public static final String DB_TYPE = "T";


    /**
     * @param readmeConfig
     */
    public ReadmeTextAttribute(InstrumentConstraintConfig readmeConfig) {
        super(readmeConfig);
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getRawValue()
     */
    public Object getRawValue() {
        return getValue();
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#isComplete()
     */
    public boolean isCompulsory() {
        InstrumentConstraintConfig conf = getReadmeConfig();
        String value = getValue();
        if(conf.isCompulsory()) {
            if(!hasValue()) {
               return false;
            } 
        }
        return true;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#verify()
     */
    public String verify() {
        InstrumentConstraintConfig conf = getReadmeConfig();
        InstrumentConstraintMetaData metaData = conf.getMetaData();
        if(!isCompulsory())
            return VERIFY_EMPTY;
        if(getValue().length() > metaData.getMaxLength()) {
            return VERIFY_TRUNCATED;    
        }
        return VERIFY_OK;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getDBType()
     */
    public static String getDBType() {
        // TODO Auto-generated method stub
        return DB_TYPE;
    }

    /* (non-Javadoc)
     * @see org.eso.ohs.instruments.ReadmeAttribute#getToolTipText()
     */
    public String getToolTipText() {
        // TODO Auto-generated method stub
        InstrumentConstraintConfig conf = getReadmeConfig();
        InstrumentConstraintMetaData metaData = conf.getMetaData();
        return "Enter Text Not greater than " + metaData.getMaxLength() + " (characters)";
    }

}
