package org.eso.ohs.persistence;

import java.util.EventListener;

/**
 * Interface implemented by listeners on object table events.
 * 
 * <p>
 * $Id: ObjectTableListener.java,v 1.1 2005/04/18 12:45:30 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */
public interface ObjectTableListener extends EventListener {

    /** 
     * "Object added" event handler.
     * 
     * @param ev    Event giving more specific details
     */
    public void tableObjectAdded(ObjectTableEvent ev);

    /**
     * Method to call when an attribute of the object has changed.
     * 
     * @param ev    Event giving more specific details,
     *		    such as which object has changed.
     */
    public void tableObjectChanged(ObjectTableEvent ev);

    /**
     * "Object removed" event handler.
     *
     * @param ev    Event giving more specific details
     */
    public void tableObjectRemoved(ObjectTableEvent ev);

}

