package org.eso.ohs.persistence.dbase.phase2;

import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;
import org.eso.ohs.persistence.Config;



/**
 *This class provides a set of static method in order to
 *interact with the phase2 database
 */

public class TmpDBIO {


   /** Standard log channel */ 
   private static Logger stdlog_ =
       Logger.getLogger( TmpDBIO.class );

 
 

   /**
   *Deletes from a table (schedule_items or exec_sequences) 
   *all data referencing a specific queue
   *@param queueId specifies the queue
   *@param tableName specifies the table in which the SQL
   *       command will be performed
   *@throws an SQLExcception if an SQL error occurs 

   */ 
  public static void deleteQueueReferenceData(long queueId,
					     String tableName,
					     Statement stmt) 
    throws SQLException 
    
  {
  String sqlText= " DELETE "  + tableName + 
                  " WHERE  " + tableName + ".sch_id  = "   + 
                   Config.getCfg().uniqueToTableId(queueId);

 



 
  stdlog_.debug(sqlText);  
  stmt.executeUpdate(sqlText);
  }

 /**
   *Copies all queue referincing data from a table to another one
   *@param queueId specifies the Id of selected queue
   *@throws an SQLExcception if an SQL error occurs
   */
  public static void copyQueueReferenceData(long queueId,
					    String sourceTable,
					    String destinationTable,
					    Statement stmt) 
                     throws SQLException
  {
  String sqlText= "INSERT INTO " + destinationTable +
                  " SELECT * FROM " + sourceTable +
                  " WHERE " + sourceTable + ".sch_id = " + 
                  Config.getCfg().uniqueToTableId(queueId);


  
  stdlog_.debug(sqlText);
  stmt.executeUpdate(sqlText);
  }

}

  


    
   







