package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.phase2.apps.p2pp.MainWindow;

/**
 * Action class to display the detailed contents of a BusinessObject.
 *
 * <p>
 * $Id: EditDbDetailsAction.java,v 1.8 2005/10/24 13:36:48 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public class EditDbDetailsAction extends ActionSuperclass {

    private ObjectContainer folderView_;

    /**
     * Constructs a ShowDetailsAction action.
     */
    public EditDbDetailsAction(ObjectContainer folderView) {
	super((JComponent)folderView, "Display Object Details");

	folderView_ = folderView;
    }

    /**
     * Event handler for the ShowDetailsAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        Long id = folderView_.getSelected();
        if (id == null){
            /** cmavros 09/11/01 */
            JOptionPane.showMessageDialog(
                folderView_.getTopLevelAncestor(),
                new Object[] {
                  "There are no selected Business Objects ",
                  "Which object do you wish to edit?",
                },
                "Nothing selected",
                JOptionPane.ERROR_MESSAGE
            );
        }
        else {
            try {
                 MainWindow.getView().showObject(Media.DBASE,id.longValue(),
                   Config.getCfg().getClassFromId(id.longValue()),true,true);               
            }
            catch(ObjectIOException e) {
                ErrorMessages.announceIOError((JComponent)folderView_,e);
            }
            catch(ObjectNotFoundException e) {
                ErrorMessages.announceNoObject((JComponent)folderView_,e);
            }
        }
    }
}
