package org.eso.ohs.phase2.icdVcs;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.eso.ohs.persistence.AppConfig;

public class CCSConnect {


   /** Standard log channel */
   private static Logger stdlog_ =
       Logger.getLogger( CCSConnect.class );

    protected BOB bob_;



    /**
     * Load the interface to BOB.
     *
     * @param className Name of a class to instanciate,
     *                  e.g. "org.eso.ohs.phase2.icdVcs.BOB" .Instantiating
     *                  the class will initialise the interface as a
     *                  side effect.
     *
     * @param masktracker Flag: initialize MaskListener yes/no.
     *  
     */


    public boolean startCcs(String className) {
	try {
            bob_ = (BOB)Class.forName(className).newInstance();           
        }
	catch (IllegalAccessException e) {
	    stdlog_.debug("Access to BOB is not available.");
	    e.printStackTrace();
	    showCcsFailureErrMsg(e);
            return false;
	}
	catch (UnsatisfiedLinkError e) {
	    stdlog_.debug("Access to BOB is not available.");
	    e.printStackTrace();
	    showCcsFailureErrMsg("CCS shared library not found: ", e);
            return false;
	}
	catch (LinkageError e) {
	    stdlog_.debug("Access to BOB is not available.");
	    e.printStackTrace();
	    showCcsFailureErrMsg("CCS Java class not found: ", e);
            return false;
	}
	catch (ClassNotFoundException e) {
	    stdlog_.debug("Access to BOB is not available.");
	    e.printStackTrace();
	    showCcsFailureErrMsg("CCS Java class not found: ", e);
            return false;
	}
	catch (Exception e) {
	    stdlog_.debug("Access to BOB is not available: "
		+ e.getMessage()
	    );
	    e.printStackTrace();
	    showCcsFailureErrMsg(e);
            return false;
	}
	return true;
    }


    public void showCcsFailureErrMsg(Throwable e) {
       showCcsFailureErrMsg(
           "No CCS connection available."
           +"\nPossible reasons for connection failure include:"
           +"\n  - configuration file missing or incorrect."
           +"\n  - RTAPENV environment variable missing or wrong."
           +"\n  - Another CCS process with the same name"
           +"\n    '"+AppConfig.getAppConfig().getCCSServer()+"' is already subscribed.",
           e);
    }

    public void showCcsFailureErrMsg(String msg, Throwable e) {
	JOptionPane.showMessageDialog(
	    null,
	    new Object[] {
		msg,
		"Error Message: "+e.getMessage()
	    },
	    "No connection to BOB",		        
	    JOptionPane.WARNING_MESSAGE		       
	);
    }
}
