package org.eso.ohs.phase2.visibility;

/**
 * Internal storage for a time and value pair.
 * @author  Nick Kornweibel for ESO
 */

import java.util.Date;

import org.eso.ohs.core.utilities.Convert;

public class PCFPoint {
    
    
    public boolean equals(Object point) {
        PCFPoint pointObj = null;
        boolean result = true; 
        if (point instanceof PCFPoint ) {
            pointObj = (PCFPoint) point;
            
            long milisecs = getStart().getTime();
            long otherMilisecs = pointObj.getStart().getTime();
            
            //if(getStart().equals(pointObj.getStart())) {
            if ( Math.abs( milisecs - otherMilisecs ) < 1000 ) {
                if (Math.abs(getValue() - pointObj.getValue()) < 0.00001) {
                    result = true;
                } else {
                    result = false;
                }
            } else {
                result = false;
            }
        } else {
            result = false;
        }
        return result;
    }
    
    private Date start_;
    private double value_;

    PCFPoint(Date start, double value) {
        start_ = start;
        value_ = value;
    }

    public Date getStart() {
        return start_;
    }

    public void setStart(Date start) {
        start_ = start;
    }

    public double getValue() {
        return value_;
    }

    public void setValue(double val) {
        value_ = val;
    }
    
    /** Overrides Object.toString() */
    // amchavan, 19-Oct-2005: added
    public String toString() {
        long from = getStart().getTime();
        String sFrom = from < 1000000 ? String.valueOf( from )
                                      : Convert.longToISODateMilliSec( from );

        StringBuffer sb = new StringBuffer();
        sb.append( "[" )
          .append( "from=" ).append( sFrom )
          .append( ",value=" ).append( getValue() )
          .append( "]" );
        return sb.toString();
    }
}
