package org.eso.ohs.phase2.visiplot;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.eso.ohs.core.gui.widgets.SimpleInputDialog;

/**
 * Open a JColorChooser and set the new colors for the chart
 * @author gdonino
 *
 */

public class ColorEditor extends SimpleInputDialog
                              implements ChangeListener {

    protected JColorChooser tcc;
    private JComponent component_;

    public ColorEditor(JComponent component, JFrame parentFrame, boolean modal, String title) {
    	 super(parentFrame, title, "", null, new Component[]{});
    

    	setTitle(title);
    	component_ = component;    
        tcc = new JColorChooser(component_.getBackground());
        tcc.getSelectionModel().addChangeListener(this);
        tcc.setBorder(BorderFactory.createTitledBorder(""));
 
        getContentPane().add(tcc, BorderLayout.PAGE_START);
    }
    
    public void stateChanged(ChangeEvent e) {
        component_.setBackground(tcc.getColor());
    }

}
